﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.3
@EndOfDesignText@
#Event: scroll(Index As Int, value As String)
'
''#DesignerProperty: Key: BooleanExample, DisplayName: Boolean Example, FieldType: Boolean, DefaultValue: True, Description: Example of a boolean property.
'#DesignerProperty: Key: left, DisplayName: left, FieldType: Int, DefaultValue: 0
'#DesignerProperty: Key: top, DisplayName: top, FieldType: Int, DefaultValue: 0
'#DesignerProperty: Key: width, DisplayName: width , FieldType: Int, DefaultValue:100,MinRange: 1, Description : 
'#DesignerProperty: Key: height, DisplayName: height, FieldType: Int, DefaultValue: 100,MinRange: 1, Description : 
'DesignerProperty: Key: itemheight, DisplayName: item height,FieldType: Int, DefaultValue: 100 
'#DesignerProperty: Key: ItemHeight, DisplayName: item height, FieldType: Int, DefaultValue: 25, Description : item height
'#DesignerProperty: Key: nbitem, DisplayName: number of items, FieldType: Int, DefaultValue: 7,MinRange: 1, Description : number of visible items
''#DesignerProperty: Key: StringWithListExample, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday
''#DesignerProperty: Key: StringExample, DisplayName: String Example, FieldType: String, DefaultValue: Text
''#DesignerProperty: Key: ColorExample, DisplayName: Color Example, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: You can use the built-in color picker to find the color values.
''#DesignerProperty: Key: DefaultColorExample, DisplayName: Default Color Example, FieldType: Color, DefaultValue: Null, Description: Setting the default value to Null means that a nullable field will be displayed.

''#DesignerProperty: Key: DefaultColorExample, DisplayName: Default Color Example, FieldType: Color, DefaultValue: Null, Description: Setting the default value to Null means that a nullable field will be displayed.
Sub Class_Globals
	Private mCallback As Object
	Private mEventName As String
	Private xui As XUI
	Private mBase As B4XView
	
	Private panel3,panel1,panel2 As B4XView
	
	Private xwh As Int
	Private npos As Double
	Private pos As Double
	Private find As Int
	
	Private xwhd As Int
	Private nbd As Int
	
	Private timer1 As Timer
	Private sv1 As ScrollView
	Private mxwlist As List
	
	Private CLV1 As CustomListView

	Private mItemHeight As Int =25dip
	Private mnbitem As Int =7	
	Private mborderw As Int=5dip
	Private mTextSize As Int= 16
	Private mborderColor As Int=xui.Color_LightGray
	
	Private xwleft As Int,xwtop As Int,xwwidth As Int
	
	Private mitem As xwtlist
	Type xwtlist(text As String,val As String)
End Sub

Public Sub  Initialize (Callback As Object, EventName As String)
		
	mCallback=Callback
	mEventName=EventName
	
End Sub

Public Sub DesignerCreateView (Base As Panel, lbl As Label , Props As Map)
	mBase = Base
	Sleep(0)
	mBase.LoadLayout("xwheeltemplate")
	
	CLV1.PressedColor=xui.Color_Transparent
	CLV1.AnimationDuration=300
		
'	mItemHeight =Props.Get("ItemHeight")
'	mnbitem=Props.get("nbitem")
	
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	If CLV1.IsInitialized Then
		CLV1.AsView.SetLayoutAnimated(300, mborderw,mborderColor, Width-2*mborderw, Height)
		CLV1.Base_Resize(Width-2*mborderw, Height)
	End If
	
End Sub

Public Sub initxwheel(xwlist As List)
	Sleep(0)
	mxwlist=xwlist
	timer1.initialize("timer1", 200)
	timer1.Enabled = False
	
	
	nbd= Floor(mnbitem/2)
	xwh=mItemHeight*mnbitem
	xwhd=mItemHeight*nbd
	
	xwwidth=mBase.Width-2*mborderw
	xwleft=mborderw
	xwtop=mborderw
		
	panel3 = xui.CreatePanel("")
	panel3.SetColorAndBorder(mborderColor,2dip,xui.Color_Black,5dip)
	CLV1.AsView.Parent.AddView(panel3,xwleft-mborderw,xwtop-mborderw,xwwidth+2*mborderw,xwh+2*mborderw)
	'mBase.AddView(panel3,xwleft-mborderw,xwtop-mborderw,xwwidth+2*mborderw,xwh+2*mborderw)
	
	panel1 = xui.CreatePanel("")
	panel3.AddView(panel1,mborderw,mborderw,xwwidth,xwh)
	Dim colorgris As Int= xui.Color_RGB(96,96,96)'RGB(80,80,80)
	Dim clr() As Int = Array  As Int(colorgris,xui.Color_white,colorgris)
	SetGradientBackground(panel1, clr, "TOP_BOTTOM")
		
	CLV1.AsView.RemoveViewFromParent
	panel1.AddView(CLV1.AsView,0,0,xwwidth,xwh)
	sv1=CLV1.sv
	sv1.Panel.Color = xui.Color_Transparent
	sv1.Height=xwh
	
	panel2=xui.CreatePanel("")
	panel1.AddView(panel2,1dip,xwhd,panel1.Width-2dip,mItemHeight)
	panel2.SetColorAndBorder(xui.Color_ARGB(32,0,0,255),2dip,xui.Color_Black,5dip)
	panel3.SendToBack
	panel2.BringToFront
	
	updateitems(mxwlist)
End Sub

Sub SetGradientBackground(pnl As B4XView, Clrs() As Int, Orientation As String)
	Dim bc As BitmapCreator
	bc.Initialize(pnl.Width / xui.Scale, pnl.Height / xui.Scale)
	bc.FillGradient(Clrs, bc.TargetRect, Orientation)
	Dim iv As ImageView
	iv.Initialize("")
	Dim xiv As B4XView = iv
	pnl.AddView(xiv, 0, 0, pnl.Width, pnl.Height)
	xiv.SendToBack
	bc.SetBitmapToImageView(bc.Bitmap, xiv)
End Sub

private Sub CreateListItem(Text As String, Width As Int, Height As Int) As B4XView
	Dim p As B4XView = xui.CreatePanel("")
	Dim l As Label
	l.Initialize("L")
	Dim xl As B4XView = l
	p.SetLayoutAnimated(0, 0, 0, Width, Height)
	p.Color=xui.Color_Transparent
	'l.Initialize("L")
	xl.SetTextAlignment("CENTER", "CENTER")
	p.AddView(xl, 0, 0, Width, Height)
	xl.color=xui.Color_Transparent
	xl.TextColor=xui.Color_black
	xl.TextSize=mTextSize
	xl.Text = Text
	Return p
End Sub

'update the items
Public Sub updateitems( nlist As List)
	If CLV1.Size<>0 Then CLV1.Clear
	For i = 1 To nbd
		CLV1.Add(CreateListItem("", CLV1.AsView.Width,mItemHeight), "0")
	Next
	
	For i=0 To nlist.Size-1
		mitem.Initialize
		mitem=nlist.Get(i)
		CLV1.Add(CreateListItem(mitem.text, CLV1.AsView.Width, mItemHeight),mitem.val)
	Next
	
	For i = 1 To nbd
		CLV1.Add(CreateListItem("", CLV1.AsView.Width,mItemHeight),"0")
	Next
End Sub



public Sub CLV1_ScrollChanged (offset As Int)
	pos=offset
	npos =mItemHeight* Floor((pos/mItemHeight)+0.5)
	timer1.Enabled=True
End Sub

private Sub timer1_tick
	Dim indc As Int
	Dim val As String
	CLV1.sv.ScrollViewOffsetY=npos
	find=CLV1.FindIndexFromOffset(npos)
	indc=find+nbd
	val=CLV1.GetValue(indc)
	timer1.Enabled =  False
	If xui.SubExists(mCallback,mEventName & "_scroll",2) Then
		CallSub3(mCallback, mEventName & "_scroll", find+1, val)
	End If
End Sub

'jump to item index (base 1)
Public Sub setItemIndex(index As Int)
	Sleep(0)
	If index<1 Or index>CLV1.Size Then Return
	CLV1.JumpToItem(index-1)
End Sub

'set the items height
Public Sub setitemheight(itemheight As Int)
	mItemHeight=itemheight
End Sub

'set the number of visible items
Public Sub setnbitem(nbitem As Int)
	mnbitem=nbitem
End Sub

'set the border width
Public Sub setborderwidth(borderwidth As Int)
	mborderw=borderwidth
End Sub

'set the border color
Public Sub setbodercolor(bordercolor As Int)
	mborderColor=bordercolor
End Sub

'set the text size
Public Sub settextsize(ItemTextSize As Int)
	mTextSize=ItemTextSize
End Sub

'